# `yasumi`

**HATEOAS-first backend framework**

This is a proposed solution to most Web frameworks that will hopefully inspire other solutions.

See [docs folder](./docs) for more details.

## Links

- Representational State Transfer

  https://ics.uci.edu/~fielding/pubs/dissertation/rest_arch_style.htm

- Roy Fielding (creator of REST)'s post about criticisms of REST APIs
  
  https://roy.gbiv.com/untangled/2008/rest-apis-must-be-hypertext-driven

- Wikipedia entry on HATEOAS

  https://en.wikipedia.org/wiki/HATEOAS

- JSON for Linked Data (JSON-LD) Specifications

  https://www.w3.org/TR/json-ld-api/

- JSON Hypertext Application Language (HAL) Specifications

  https://datatracker.ietf.org/doc/html/draft-kelly-json-hal-11

- Valibot (zod alternative)

  https://valibot.dev/

- Content negotiation

  https://developer.mozilla.org/en-US/docs/Web/HTTP/Content_negotiation

- RFC 9457 - Problem Details for HTTP APIs

  https://www.rfc-editor.org/rfc/rfc9457.html

- ~~RFC 5988 - Web Linking~~

  ~~https://datatracker.ietf.org/doc/html/rfc5988~~

- RFC 9288 - Web Linking

  https://httpwg.org/specs/rfc8288.html

- JSON Patch and JSON Merge Patch

  https://erosb.github.io/post/json-patch-vs-merge-patch/

- Patch vs merge-patch which is appropriate?

  https://stackoverflow.com/questions/56030328/patch-vs-merge-patch-which-is-appropriate

- PATCH Method for HTTP

  https://www.rfc-editor.org/rfc/rfc5789

- JavaScript Object Notation (JSON) Patch

  https://www.rfc-editor.org/rfc/rfc6902 

- ~~HTTP SEARCH Method~~

  ~~https://www.ietf.org/archive/id/draft-ietf-httpbis-safe-method-w-body-00.html~~

- The HTTP QUERY Method

  https://www.ietf.org/archive/id/draft-ietf-httpbis-safe-method-w-body-02.html

- URL Standard

  https://url.spec.whatwg.org/#urlencoded-parsing

  https://url.spec.whatwg.org/#interface-urlsearchparams

- 303 See Other

  https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/303
