import {ServiceParams, App as BaseApp, Endpoint, GetEndpointParams, Operation} from '../common';

export interface ClientParams<App extends BaseApp> {
	app: App;
	fetch?: typeof fetch;
}

export interface ClientConnection {}

export interface Client<App extends BaseApp = BaseApp, Connection extends ClientConnection = ClientConnection> {
	app: App;
	connect(params: ServiceParams): Promise<Connection>;
	disconnect(connection?: Connection): Promise<void>;
	at<TheEndpoint extends Endpoint = Endpoint>(endpoint: TheEndpoint, params?: Record<GetEndpointParams<TheEndpoint>, unknown>): this;
	makeRequest(operation: Operation): ReturnType<typeof fetch>;
}
