type ObjectWithName<Name extends string = string> = {
	name: Name;
};

export type NamedSet<T extends ObjectWithName> = Map<T['name'], T>;

export class PredicateMap<K, V> extends Map<K, V> {
	static get [Symbol.species]() {
		return Map;
	}

	constructor(private readonly predicate: (newItem: V, existingItem: V) => boolean, arg0?: ConstructorParameters<typeof Map<K, V>>[0]) {
		super(arg0);
	}

	set(key: K, value: V) {
		for (const a of this.values()) {
			if (this.predicate(value, a)) {
				return this;
			}
		}

		super.set(key, value);
		return this;
	}
}
