import {
	app,
	composeRecipes,
} from '@modal-sh/yasumi';
import {
	DataSource
} from '@modal-sh/yasumi/backend';
import {server} from '@modal-sh/yasumi-extender-http/backend';
import {addResourceRecipe} from '@modal-sh/yasumi-recipe-resource';

export const setupApp = (dataSource: DataSource) => {
	const {
		app: theApp,
		operations,
		backend: theBackend,
	} = composeRecipes([
		addResourceRecipe({ endpointName: 'users', dataSource, }),
		addResourceRecipe({ endpointName: 'posts', dataSource, })
	])({
		app: app({
			name: 'default' as const,
		}),
	});

	const theServer = typeof theBackend !== 'undefined' ? server({
		backend: theBackend,
	}) : undefined;

	return {
		app: theApp,
		operations,
		server: theServer,
	};
};
